Bug 13446 - dfree cache returning incorrect data for sub directory mounts
dfree cache returning incorrect data for sub directory mounts
Status: RESOLVED FIXED
Product: Samba 4.1 and newer
Classification: Unclassified
Component: File services
4.8.2
All All
: P5 normal
: ---
Assigned To: Karolin Seeger
Samba QA Contact
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2018-05-18 23:35 UTC by Christof Schmitt
Modified: 2018-06-19 10:49 UTC (History)
1 user (show)

See Also:


Attachments
patches for 4.8 (11.76 KB, patch)
2018-06-04 19:28 UTC, Christof Schmitt
jra: review+
Details
patches for 4.7 (11.66 KB, patch)
2018-06-04 19:57 UTC, Christof Schmitt
jra: review+
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Christof Schmitt 2018-05-18 23:35:33 UTC
This was found with gpfs, but it also applies to other setups.

Given a setup with different file system mounts.

/smbexport/fs1/
/smbexport/fs2/

and a SMB share exporting mount (//server/smbexport). A Windows client
can map //server/smbexport/fs1 and //server/smbexport/fs2 to different
drive letters. Querying available space on each of the mapped drives
results in free space queries to the correct path. With 'dfree cache timeout'
set, smbd caches the free space information per SMB share. That means
that the first query (e.g. to  //server/smbexport/fs1) returns the
correct free space information, but a following query to the other
path returns the wrong result (e.g. querying for //server/smbexport/fs2 will
now return the available space for fs1 from the cache).

To support this correctly, the solution would be to not cache on the
SMB share level, but for the individual query.
Comment 1 Christof Schmitt 2018-06-04 19:28:43 UTC
Created attachment 14220 [details]
patches for 4.8
Comment 2 Christof Schmitt 2018-06-04 19:57:46 UTC
Created attachment 14221 [details]
patches for 4.7
Comment 3 Jeremy Allison 2018-06-07 07:13:19 UTC
Reassigning to Karolin for inclusion in 4.7.next, 4.8.next.
Comment 4 Karolin Seeger 2018-06-07 07:40:15 UTC
(In reply to Jeremy Allison from comment #3)
Pushed to autobuild-v4-{8,7}-test.
Comment 5 Karolin Seeger 2018-06-19 10:49:29 UTC
(In reply to Karolin Seeger from comment #4)
Pushed to both branches.
Closing out bug report.

Thanks!